#!/usr/bin/env python
#-*- coding:utf-8 –*-
#-----------------------------------------------------------------------------
# $Header: $
#-----------------------------------------------------------------------------
# Summary:          Implementation of Serial Number Scanning Dialog
#
# Authors:          Jensen.Cai
#
# Started:          11/25/2014
#
# Version:          V1.7R1
#  
# Copyright 2013-2016 Siglent Corporation. All Rights Reserved.
#
#-----------------------------------------------------------------------------

from PyQt4.QtCore import *  
from PyQt4.QtGui import *  
import sys, re

#-----------------------------------------------------------------------------

QTextCodec.setCodecForTr(QTextCodec.codecForName('utf8'))  

#----------------------------------------------------------------------------- 
class InputDlg(QDialog):
    def __init__(self,def_SerialNo,parent=None):
        #扫描框基本布局
        super(InputDlg,self).__init__(parent)  
  
        self.main_label=QLabel(self.tr('序列号 Serial Number'))  
        self.SerialNo = def_SerialNo
        self.SerialNo_label=QLabel(self.SerialNo)  
        self.SerialNo_label.setFrameStyle(QFrame.Panel|QFrame.Sunken)
        
        SerialNo_button=QPushButton(self.tr('开始 Start'))  
  
        self.connect(SerialNo_button,SIGNAL('clicked()'),self.slotSerialNo)
  
        layout=QGridLayout()
        layout.addWidget(self.main_label,2,1)
        layout.addWidget(self.SerialNo_label,2,2)  
        layout.addWidget(SerialNo_button,2,3)
  
        self.setLayout(layout)
  
        self.setWindowTitle(self.tr('扫描序列号 S/N Scanning'))  
  
    def slotSerialNo(self):
        #开始扫描时的输入框
        SerialNo,ok=QInputDialog.getText(self,self.tr('序列号 Serial Number'),  
                                     self.tr('请使用条码枪进行扫描: Please scan the product barcode'),  
                                     QLineEdit.Normal,self.SerialNo_label.text())  
        if ok and (not SerialNo.isEmpty()):
            if SerialNo != self.SerialNo:
                self.SerialNo_label.setText(SerialNo)
                self.SerialNo = SerialNo
                self.close()
            else:
                self.main_label.setText(self.tr('非法操作: 序列号与扫描前相同！Illegal operation: The same S/N has been saved!'))

    def getSerialNo(self):
        #获取扫描得到的序列号
        return self.SerialNo
    
#-----------------------------------------------------------------------------
def scanSerialNo(init_SN):
    app=QApplication(sys.argv)  
    scan_box=InputDlg(init_SN)  
    scan_box.show()
    app.exec_()
    if scan_box.getSerialNo() == init_SN:
        #若直接关闭窗口将返回初始序列号，此时提示误操作
        print u'扫描窗口非正常关闭，请重新操作\nThe scanning window is closed unexpectedly, please try it again!'
        raw_input()
        exit()
    else:
        return scan_box.getSerialNo()

if __name__ == '__main__':
    print scanSerialNo('LCRY000')
