#!/usr/bin/env python
#-*- coding:utf-8 –*-
#-----------------------------------------------------------------------------
# $Header: $
#-----------------------------------------------------------------------------
# Summary:          Implementation of easyExcel Class
#
# Authors:          Jensen.Cai
#
# Started:          11/25/2014
#
# Version:          V1.7R1
# 
# Copyright 2013-2016 Siglent Corporation. All Rights Reserved.
#
#-----------------------------------------------------------------------------

import win32com.client
import time

#-----------------------------------------------------------------------------
class easyExcel:
    def __init__(self,filename=None):
        self.xlApp=win32com.client.Dispatch('Excel.Application')
        if filename:
            self.filename=filename
            self.xlBook=self.xlApp.Workbooks.Open(filename)
        else:
            self.xlBook=self.xlApp.Workbooks.Add()
            self.filename=''
    def save(self,newfilename=None):
        #保存Excel
        if newfilename:
            self.filename=newfilename
            self.xlBook.SaveAs(newfilename)
        else:
            self.xlBook.Save()
    def close(self):
        #关闭Excel
        self.xlBook.Close(SaveChanges=0)
        del self.xlApp
    def getCell(self,sheet,row,col):
        #获取Excel单元格内容
        sht=self.xlBook.Worksheets(sheet)
        return sht.Cells(row,col).Value
    def setCell(self,sheet,row,col,value):
        #写入Excel单元格
        sht=self.xlBook.Worksheets(sheet)
        sht.Cells(row,col).Value=value
    def setMergeCell(self,sheet,head_row,head_col,tail_row,tail_col,value,color):
        #合并单元格并写入 （color：无色为0，黑为1，白为2，红为3，绿为4，蓝为5）
        sht=self.xlBook.Worksheets(sheet)
        sht_range = sht.Range(sht.Cells(head_row,head_col),sht.Cells(tail_row,tail_col))
        sht_range.MergeCells = True
        sht_range.Value = value
        sht_range.Font.Bold = True
        sht_range.Interior.ColorIndex = color
        
#-----------------------------------------------------------------------------
if __name__=='__main__':
    print 1
    f=easyExcel(r'D:\Flatness.xls')
    print 2
    time.sleep(2)
    f.setCell('Sheet1',14,7,'1.24534878')
    print 3
    time.sleep(1)
    f.save()
    print 4
    time.sleep(1)
    f.close()
    print 5
